



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>OC静态库里NSClassFromString得到nil的解决</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">OC静态库里NSClassFromString得到nil的解决</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 22:27:28 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>如果你在静态库中有从类名反射回类的代码, 如下:</p>
<pre class="prettyprint linenums"><code>NSString *myClassStr = @"myClass";<br />
Class myClazz = NSClassFromString(myClassStr);<br />
if (myClazz) {<br />
    id myClassInit = [[myClazz alloc] init];<br />
}<br />
</code></pre>
<p><code>有时候</code>(经常)会出现得到了Class为nil的情况, 网上搜索, 一般是这么说的:</p>
<pre class="prettyprint linenums"><code>The class object named by aClassName, or nil if no class by that name is currently loaded. If aClassName is nil, returns nil.<br />
</code></pre>
<p>来自于64位系统的一个bug:</p>
<pre class="prettyprint linenums"><code>IMPORTANT: For 64-bit and iPhone OS applications, there is a linker bug that prevents -ObjC from loading objects files from static libraries that contain only categories and no classes. The workaround is to use the -all_load or -force_load flags. -all_load forces the linker to load all object files from every archive it sees, even those without Objective-C code. -force_load is available in Xcode 3.2 and later. It allows finer grain control of archive loading. Each -force_load option must be followed by a path to an archive, and every object file in that archive will be loaded.<br />
</code></pre>
<p>就我的实测<br />首先, 你需要在你的主项目(的target)对build setting进行更改, 而不是静态库的项目!<br />其次,&nbsp;<code>-all_load</code>有效,&nbsp;<code>-force_load</code>甚至编译都过不了<br />最后, 结合上面, 就是在主项目(引用静态库的项目)的build setting里面搜索<code>other linker flags</code>, 然后把<code>-all_load</code>加进去就行了</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49ggnke9.html">用clock（）函数计算多项式的运行时间</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o61y58.html">windows下scrapy 的安装</a>
		</li>
						<li><a href="https://www.batexi.com/a/qn1d4x28.html">C和C&plus;&plus;中结构体&lpar;struct&rpar;、联合体&lpar;union&rpar;、枚举&lpar;enum&rpar;的区别</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2wngm3q.html">PHP5&period;5安装php-redis扩展</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x2yzr9.html">oracle积累继续</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn7wdpq.html">Count Complete Tree Nodes &mdash;&mdash;LeetCode</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdmerd9.html">dfs手写栈模板</a>
		</li>
						<li><a href="https://www.batexi.com/a/950vorm8.html">mongo分布式集群搭建手记</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwje35k8.html">css系统学习网站</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwj33g38.html">用 Java 解密 C&num; 加密的数据&lpar;DES&rpar;&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gdd76q.html">Linux学习8-CentOS部署自己本地的django项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j1xyng9.html">把myeclipse的自动验证和自动构建都关掉</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4j25o3q.html">oracle数据库自增主键重复</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwlw7y8.html">Azure PowerShell &lpar;13&rpar; 批量设置Azure ARM Network Security Group &lpar;NSG&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9jmzwn09.html">powerdesigner 不显示表字段只显示表名</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdjk3mzq.html">DCL，即Double Check Lock，中卫双重检查锁定。</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwle5kr9.html">Android自己定义控件：进度条的四种实现方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rn3jndq.html">【Javascript】Javascript横向&sol;纵向合并单元格TD</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pp5p3k9.html">curl命令踩的坑</a>
		</li>
						<li><a href="https://www.batexi.com/a/953knge8.html">Java常用的转义字符</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/m8zw7718.html">C&num; FTP FtpWebRequest UsePassive 属性</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7r1yx8.html">&lbrack;LeetCode&rsqb; Number of Islands II</a>
			</li>
						<li><a href="https://www.batexi.com/a/r8m04069.html">从javascript一道闭包面试题说开去</a>
			</li>
						<li><a href="https://www.batexi.com/a/4qnoe7x9.html">&lbrack;PaPaPa&rsqb;&lbrack;需求说明书&rsqb;&lbrack;V0&period;2&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/2q7ry3k8.html">Oracle数据库入门&mdash;&mdash;pctfree和pctused详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/o8k7ez79.html">linux samba 服务配置及日志管理</a>
			</li>
						<li><a href="https://www.batexi.com/a/m8zwz5v8.html">【开源框架】EFW框架中的系统权限与页面子权限详解</a>
			</li>
						<li><a href="https://www.batexi.com/a/m96evonq.html">［fun code - 模拟］孤独的&OpenCurlyDoubleQuote;7&rdquo;</a>
			</li>
						<li><a href="https://www.batexi.com/a/e9j3wreq.html">position 属性和 z-index 属性对页面节点层级影响的例子</a>
			</li>
						<li><a href="https://www.batexi.com/a/r93zee0q.html">固态硬盘寿命实测让你直观SSD寿命！--转</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
